package lt.bit.prekes.models;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity						//Nurodo jog šios klasės objektai bus sukabinti su DB eilutėmis
@Table(name="products")     //Nurodome jog tai yra lentelė ir lenteles pavadinimas yra product
public class Product {
	@Id						//Nurodome jog atributas yra DB identifikatorius 
	@GeneratedValue(strategy = GenerationType.IDENTITY)
							//Nurodome jog atributas bus auto increment
	private int id;
	
	@Column					//Nurodome jog atributas bus DB laukelis
	private String name;
	
	@Column(nullable = true)
	private Double price;
	
	@Column
	private String barcode;
	
	@ManyToOne
	@JoinColumn(name = "category_id")
	private Category category;
	
	public Product() {
		
	}
	

	public Product( String name, Double price) {
		this.name = name;
		this.price = price;
	}
	
	

	public Product(String name, Double price, String barcode) {
		super();
		this.name = name;
		this.price = price;
		this.barcode = barcode;
	}


	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}


	public String getBarcode() {
		return barcode;
	}


	public void setBarcode(String barcode) {
		this.barcode = barcode;
	}
	
	
	public String toString() {
		return this.name+" "+this.price+" "+this.barcode;
	}


	public Category getCategory() {
		return category;
	}


	public void setCategory(Category category) {
		this.category = category;
	}


}
