package lt.bit.prekes.servlets;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.hibernate.Session;

import lt.bit.prekes.db.Db;
import lt.bit.prekes.models.Category;
import lt.bit.prekes.models.Product;

/**
 * Servlet implementation class ProductUpdate
 */
@WebServlet("/update")
public class ProductUpdate extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ProductUpdate() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Integer id=Integer.parseInt(request.getParameter("id"));
		
		Session session=Db.getSessionFactory().openSession();
		
		Product p=session.get(Product.class, id);
		List<Category> categories=session.createQuery("SELECT c FROM Category c", Category.class).getResultList();
				
		session.close();
		
		request.setAttribute("product", p);
		request.setAttribute("categories",categories);
		
		RequestDispatcher dispatcher=request.getRequestDispatcher("/update.jsp"); 
		dispatcher.forward(request, response);
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Integer id=Integer.parseInt(request.getParameter("id"));  
		Integer catgoryId=Integer.parseInt(request.getParameter("category_id"));
		
		String name=request.getParameter("name");
		Double price=Double.parseDouble(request.getParameter("price"));
		String barcode=request.getParameter("barcode");
		
		Session session=Db.getSessionFactory().openSession();
		session.beginTransaction();
		
		Product p=session.get(Product.class, id);
		Category c=session.get(Category.class, catgoryId);
		p.setName(name);
		p.setPrice(price);
		p.setBarcode(barcode);
		p.setCategory(c);
		
		session.save(p);
		
		session.getTransaction().commit();
		session.close();
		
		response.sendRedirect( request.getContextPath()+"/home");
	}

}
